package com.rootsoft.broadcastreceiver;

import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.objects.ServiceHelper;
import anywheresoftware.b4a.debug.*;

public class receiver extends android.app.Service {
	public static class receiver_BR extends android.content.BroadcastReceiver {

		@Override
		public void onReceive(android.content.Context context, android.content.Intent intent) {
			android.content.Intent in = new android.content.Intent(context, receiver.class);
			if (intent != null)
				in.putExtra("b4a_internal_intent", intent);
			context.startService(in);
		}

	}
    static receiver mostCurrent;
	public static BA processBA;
    private ServiceHelper _service;
    public static Class<?> getObject() {
		return receiver.class;
	}
	@Override
	public void onCreate() {
        mostCurrent = this;
        if (processBA == null) {
		    processBA = new BA(this, null, null, "com.rootsoft.broadcastreceiver", "receiver");
            main.initializeProcessGlobals();
            processBA.loadHtSubs(this.getClass());
            ServiceHelper.init();
        }
        _service = new ServiceHelper(this);
        processBA.service = this;
        processBA.setActivityPaused(false);
        anywheresoftware.b4a.keywords.Common.Log("** Service (receiver) Create **");
        processBA.raiseEvent(null, "service_create");
    }
		@Override
	public void onStart(android.content.Intent intent, int startId) {
		handleStart(intent);
    }
    @Override
    public int onStartCommand(android.content.Intent intent, int flags, int startId) {
    	handleStart(intent);
		return android.app.Service.START_NOT_STICKY;
    }
    private void handleStart(android.content.Intent intent) {
    	anywheresoftware.b4a.keywords.Common.Log("** Service (receiver) Start **");
    	java.lang.reflect.Method startEvent = processBA.htSubs.get("service_start");
    	if (startEvent != null) {
    		if (startEvent.getParameterTypes().length > 0) {
    			anywheresoftware.b4a.objects.IntentWrapper iw = new anywheresoftware.b4a.objects.IntentWrapper();
    			if (intent != null) {
    				if (intent.hasExtra("b4a_internal_intent"))
    					iw.setObject((android.content.Intent) intent.getParcelableExtra("b4a_internal_intent"));
    				else
    					iw.setObject(intent);
    			}
    			processBA.raiseEvent(null, "service_start", iw);
    		}
    		else {
    			processBA.raiseEvent(null, "service_start");
    		}
    	}
    }
	@Override
	public android.os.IBinder onBind(android.content.Intent intent) {
		return null;
	}
	@Override
	public void onDestroy() {
        anywheresoftware.b4a.keywords.Common.Log("** Service (receiver) Destroy **");
		processBA.raiseEvent(null, "service_destroy");
        processBA.service = null;
		mostCurrent = null;
		processBA.setActivityPaused(true);
	}
public anywheresoftware.b4a.keywords.Common __c = null;
public static com.rootsoft.broadcastreceiver.BroadCastReceiver _broadcast = null;
public main _main = null;
public static String  _broadcastreceiver_onreceive(String _action) throws Exception{
 //BA.debugLineNum = 29;BA.debugLine="Sub BroadcastReceiver_OnReceive (Action As String)";
 //BA.debugLineNum = 30;BA.debugLine="ToastMessageShow(Action,False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow(_action,anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 32;BA.debugLine="Broadcast.AbortBroadcast";
_broadcast.AbortBroadcast();
 //BA.debugLineNum = 33;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 2;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 5;BA.debugLine="Dim Broadcast As BroadCastReceiver";
_broadcast = new com.rootsoft.broadcastreceiver.BroadCastReceiver();
 //BA.debugLineNum = 7;BA.debugLine="End Sub";
return "";
}
public static String  _service_create() throws Exception{
 //BA.debugLineNum = 8;BA.debugLine="Sub Service_Create";
 //BA.debugLineNum = 10;BA.debugLine="Broadcast.Initialize(\"BroadcastReceiver\")";
_broadcast.Initialize(processBA,"BroadcastReceiver");
 //BA.debugLineNum = 13;BA.debugLine="End Sub";
return "";
}
public static String  _service_destroy() throws Exception{
 //BA.debugLineNum = 25;BA.debugLine="Sub Service_Destroy";
 //BA.debugLineNum = 27;BA.debugLine="End Sub";
return "";
}
public static String  _service_start(anywheresoftware.b4a.objects.IntentWrapper _startingintent) throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Service_Start (StartingIntent As Intent)";
 //BA.debugLineNum = 18;BA.debugLine="Broadcast.addAction(\"android.provider.Telephony.SMS_RECEIVE\")";
_broadcast.addAction("android.provider.Telephony.SMS_RECEIVE");
 //BA.debugLineNum = 19;BA.debugLine="Broadcast.addAction(Broadcast.SMS_RECEIVED)";
_broadcast.addAction(_broadcast.SMS_RECEIVED);
 //BA.debugLineNum = 20;BA.debugLine="Broadcast.SetPriority(2147483647)";
_broadcast.SetPriority((int)(2147483647));
 //BA.debugLineNum = 21;BA.debugLine="Broadcast.registerReceiver(\"\") 'here you can add the main action (intent)";
_broadcast.registerReceiver("");
 //BA.debugLineNum = 23;BA.debugLine="End Sub";
return "";
}
}
