﻿Type=Service
Version=1.70
StartAtBoot=False
@EndOfDesignText@
'Service module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim Broadcast As BroadCastReceiver

End Sub
Sub Service_Create

	Broadcast.Initialize("BroadcastReceiver")
	

End Sub

Sub Service_Start (StartingIntent As Intent)
	
	'This starts listening for all broadcasts that has the following string: "android.provider.Telephony.SMS_RECEIVED" and sets the priority to the maximum. (this means it will try to first call this receiver)
	Broadcast.addAction("android.provider.Telephony.SMS_RECEIVE")
	Broadcast.addAction(Broadcast.SMS_RECEIVED)
	Broadcast.SetPriority(2147483647)
	Broadcast.registerReceiver("") 'here you can add the main action (intent)

End Sub

Sub Service_Destroy

End Sub

Sub BroadcastReceiver_OnReceive (Action As String)
	ToastMessageShow(Action,False)
	'can only abort when sendOrderedbroadcast is called.
	Broadcast.AbortBroadcast
End Sub
